/*
      SoundMan v0.1 - Realtime frequency analyzer
      Copyright (C) 1999 Gabor Kerenyi (wom@fireball.kalmar.hu)
*/

/**********************************************************************

	--- Qt Architect generated file ---

	File: filter.cpp
	Last generated: Wed Jan 13 05:10:07 1999

 *********************************************************************/

#include "filter.h"
#include <ctype.h>
#include "main.h"
#include <stdio.h>
#include <qmessagebox.h>
#include <qapplication.h>
#include "fft.h"
#include <math.h>
#include <qprogressbar.h>
#include <qprogressdialog.h>

#define Inherited filterData

extern cnf mconf;
int db;
int *ej;
Fft *fft;
float least_power;
float biggest_power;

filter::filter
(
	QWidget* parent,
	const char* name
)
	:
	Inherited( parent, name )
{
filter_low=FALSE;
sub_filter=FALSE;
noisesub=FALSE;
sub(FALSE);
low_filter(FALSE);
filtering_percent=0;
filtering_xtimes=0;
}


int isnumber(char *c)
{
  int ok;
  int i;
  ok=1;
  for (i=0;i<strlen(c);i++)
  {
     if (isdigit(c[i])==0) ok=0;
  }
  return ok;
}

void filter::remove()
{
int i;

  i=fr_start->currentItem();
  fr_start->removeItem(i);
  fr_end->removeItem(i);
  ampl->removeItem(i);
  time_start->removeItem(i);
  time_end->removeItem(i);
}

void filter::removep(int j)
{
  fr_start->removeItem(j);
  fr_end->removeItem(j);
  ampl->removeItem(j);
  time_start->removeItem(j);
  time_end->removeItem(j);
}

void filter::noise_sub(bool i)
{
noisesub=i;
}


void filter::sel(int i)
{
  fr_end->setSelected(i,TRUE);
  ampl->setSelected(i,TRUE);
  time_start->setSelected(i,TRUE);
  time_end->setSelected(i,TRUE);
  fr_start->setSelected(i,TRUE);

  edit_fr_start->clear();
  edit_fr_end->clear();
  edit_ampl->clear();
  edit_filter_start->clear();
  edit_filter_end->clear();

  edit_fr_start->insert(fr_start->text(i));
  edit_fr_end->insert(fr_end->text(i));
  edit_ampl->insert(ampl->text(i));
  edit_filter_start->insert(time_start->text(i));
  edit_filter_end->insert(time_end->text(i));
}


void filter::additem()
{
 char cfstart[16];
 char cfend[16];
 char campl[16];
 char cfistart[16];
 char cfiend[16];
 char error[128];
 int ido;

 strcpy(cfstart,edit_fr_start->text());
 strcpy(cfend,edit_fr_end->text());
 strcpy(campl,edit_ampl->text());
 strcpy(cfistart,edit_filter_start->text());
 strcpy(cfiend,edit_filter_end->text());
 strcpy(error,"");
 if ((strlen(cfstart)<1)||(isnumber(cfstart)==0))
    strcpy(error,"You didn't give the value of the frequency\n, or it is invalid.\n");
 if ((strlen(cfend)==0))
    strcpy(cfend,cfstart);
 else 
    if (isnumber(cfend)==0)
       strcpy(error,"The value of ending frequency contains an illagal character!");
 if ((strlen(campl)<1)||(isnumber(campl)==0))
    strcpy(error,"The masking field (amplitude) is empty or it contains illegal character!");
 if (strlen(cfistart)<1)
    strcpy(cfistart,"0");
 else 
    if (isnumber(cfistart)==0)
        strcpy(error,"The beginning of filtering is not given correctly!");
 ido=mconf.dev.ido;
 if (strlen(cfiend)<1)
    sprintf(cfiend,"%d",ido);
 else
    if (isnumber(cfiend)==0)
        strcpy(error,"The ending frequency is not given correctly!");
 if (strlen(error)==0){
    fr_start->insertItem(cfstart);
    fr_end->insertItem(cfend);
    ampl->insertItem(campl);
    time_start->insertItem(cfistart);
    time_end->insertItem(cfiend);
 }
 else {
    QMessageBox::warning(this,"FFT Frequency Filter",error);
 }
}

void filter::additemp(int i)
{
 char cfstart[16];
 char cfend[16];
 char campl[16];
 char cfistart[16];
 char cfiend[16];
 char error[128];
 int ido;

 strcpy(cfstart,edit_fr_start->text());
 strcpy(cfend,edit_fr_end->text());
 strcpy(campl,edit_ampl->text());
 strcpy(cfistart,edit_filter_start->text());
 strcpy(cfiend,edit_filter_end->text());
 strcpy(error,"");
 ido=mconf.dev.ido;
 if ((strlen(cfstart)<1)||(isnumber(cfstart)==0))
    strcpy(error,"The starting value of the frequency is not given, or it contains illegal characters!");
 if ((strlen(cfend)==0))
    strcpy(cfend,cfstart);
 else
    if (isnumber(cfend)==0)
       strcpy(error,"The ending frequency contains illegal characters!");
 if ((strlen(campl)<1)||(isnumber(campl)==0)) 
    strcpy(error,"The masking value(amplitude) contains illegal characters,or it's empty!");
 if (strlen(cfistart)<1)
    strcpy(cfistart,"0");
 else
    if (isnumber(cfistart)==0)
       strcpy(error,"The begenning of filtering is given incorrectly!");
 ido=mconf.dev.ido;
 if (strlen(cfiend)<1)
    sprintf(cfiend,"%d",ido);
 else
    if (isnumber(cfiend)==0)
       strcpy(error,"A szures vege helytelenul lett megadva!");
 if (strlen(error)==0){
    fr_start->insertItem(cfstart,i);
    fr_end->insertItem(cfend,i);
    ampl->insertItem(campl,i);
    time_start->insertItem(cfistart,i);
    time_end->insertItem(cfiend,i);
 }
 else {
    QMessageBox::warning(this,"FFT Frequancy Filter",error);
 }
}


void  filter::up()
{
  int i=fr_start->currentItem();
if (i>0){
  additemp(i-1); 
  removep(i+1);
  sel(i-1);
}
}

void  filter::down()
{
  int i=fr_start->currentItem();
if (i<fr_start->count()){
  additemp(i+2); 
  removep(i);
  sel(i+1);
}
}


void filter::change()
{
int i=fr_start->currentItem();
 char cfstart[16];
 char cfend[16];
 char campl[16];
 char cfistart[16];
 char cfiend[16];
 char error[128];
 int ido;

 strcpy(cfstart,edit_fr_start->text());
 strcpy(cfend,edit_fr_end->text());
 strcpy(campl,edit_ampl->text());
 strcpy(cfistart,edit_filter_start->text());
 strcpy(cfiend,edit_filter_end->text());
 strcpy(error,"");
 if ((strlen(cfstart)<1)||(isnumber(cfstart)==0))
    strcpy(error,"The beginning of frequency is incorrect, or it's empty!");
 if ((strlen(cfend)==0))
    strcpy(cfend,cfstart);
 else
    if (isnumber(cfend)==0)
       strcpy(error,"The ending frequency contains illegal characters!");
 if ((strlen(campl)<1)||(isnumber(campl)==0))
    strcpy(error,"The masking field(amplitude) contains illegal characters, or it's empty!");
 if (strlen(cfistart)<1)
    strcpy(cfistart,"0");
 else
    if (isnumber(cfistart)==0)
       strcpy(error,"The beginning of filtering is given incorrectly!");
 ido=mconf.dev.ido;
 if (strlen(cfiend)<1)
    sprintf(cfiend,"%d",ido);
 else
    if (isnumber(cfiend)==0)
       strcpy(error,"The ending of filtering is given incorrectly!");
 if (strlen(error)==0){
    fr_start->changeItem(cfstart,i);
    fr_end->changeItem(cfend,i);
    ampl->changeItem(campl,i);
    time_start->changeItem(cfistart,i);
    time_end->changeItem(cfiend,i);
 }
}

void calc_power(int length)
{
int i;
double tmp,tmp1,tmp2;
  
for (i=0;i<length;i++)
{
  if ((mconf.spect.source+i)->re<0) {
     *(ej+i)=1;
  }
  else 
     *(ej+i)=0;
  tmp=(mconf.spect.source+i)->re*(mconf.spect.source+i)->re;
  tmp1=(mconf.spect.source+i)->im*(mconf.spect.source+i)->im;
  tmp2=tmp+tmp1;
  *(mconf.spect.power+i)=sqrt(tmp2);
  tmp=(mconf.spect.source+i)->im/(mconf.spect.source+i)->re;
  tmp1=-tmp;
  tmp2=atan(tmp1);
  *(mconf.spect.phase+i)=tmp2;
} 
}

void calc_cx(int length)
{
int i;
double tmp;

for (i=0;i<length;i++)
{
  (mconf.spect.source+i)->re=*(mconf.spect.power+i)*cos(*(mconf.spect.phase+i));
  tmp=*(mconf.spect.power+i)*sin(*(mconf.spect.phase+i));
  (mconf.spect.source+i)->im=-tmp;
  if (*(ej+i)) {
     (mconf.spect.source+i)->re*=(-1);
     (mconf.spect.source+i)->im*=(-1);
  }
}
}

void filter::szur(int k,int length)
{
int j,m;
float pow,pow1,pow2;
float i;
float t1;

pow=0;
for (j=1;j<length/2;j++)
{
     pow+=2.0*(*(mconf.spect.power+j))*(*(mconf.spect.power+j));
}
t1=(float)k*((float)length/(float)mconf.wave.freq);
least_power=biggest_power/100.0;
if ((filter_low)||(sub_filter)||(noisesub))
  for (j=1;j<length/2;j++)
  {
  if (filter_low)
      if (*(mconf.spect.power+j)/biggest_power<(float)filtering_percent/(float)100)
	{
		*(mconf.spect.power+j)=0.0;
		*(mconf.spect.power+length-j-1)=0.0;
	}
  if (noisesub){
	if ((*(mconf.spect.power+j)-=*(mconf.noise+j))<0)
	   *(mconf.spect.power+j)=0;
	if ((*(mconf.spect.power+length-j-1)-=*(mconf.noise+length-j-1))<0)
	   *(mconf.spect.power+length-j-1)=0;
	
  }
  if (sub_filter)
      if (*(mconf.spect.power+j)>(float)filtering_xtimes*least_power)
	{
		*(mconf.spect.power+j)-=(float)filtering_xtimes*least_power;
		*(mconf.spect.power+length-j-1)-=(float)filtering_xtimes*least_power;
	}
	else{
		*(mconf.spect.power+length-j-1)=0.0;
		*(mconf.spect.power+j)=0.0;
	}
  }
for (m=0;m<db;m++){
  if ((t1>=(mconf.nf+m)->time_start )&&(t1<=(mconf.nf+m)->time_end))
  {
     for (j=1;j<length/2;j++)
     {
        i=(float)(mconf.wave.freq/2)/(length/2);
        if (((float)j*i>=(mconf.nf+m)->fr_start)&&((float)j*i<=(mconf.nf+m)->fr_end))
	{
            *(mconf.spect.power+j)*=((float)(mconf.nf+m)->ampl/(float)100);
            *(mconf.spect.power+length-j-1)*=((float)(mconf.nf+m)->ampl/(float)100);
	}
     }
  }
}
pow1=0;
for (j=1;j<length/2;j++)
{
     pow1+=2.0*(*(mconf.spect.power+j))*(*(mconf.spect.power+j));
}
pow2=*(mconf.spect.power)*(*(mconf.spect.power));
}

void filter::low_filter(bool i)
{
   if (i){
	label1->show();
	label3->show();
	percent->show();
	filter_low=TRUE;
   }
   else
   {
	label1->hide();
	label3->hide();
	percent->hide();
	filter_low=FALSE;
   }
}

void filter::sub(bool i)
{
   if (i){
	label2->show();
	label4->show();
	xtimes->show();
	sub_filter=TRUE;
   }
   else {
	label2->hide();
	label4->hide();
	xtimes->hide();
	sub_filter=FALSE;
   }
}

void filter::percent_ch(int i)
{
   filtering_percent=i;
}

void filter::xtimes_ch(int i)
{
   filtering_xtimes=i;
}

void filter::search_for_lnh(int length)
{
int i,j;

for (i=0;i<mconf.wave.rec_pn-length;i+=length)
{
   for (j=0;j<length;j++)
   {
	(mconf.spect.source+j)->re=*(mconf.wave.wave+i+j);
	(mconf.spect.source+j)->im=0;	
   }
   fft->fft();
   calc_power(length);
   if (i==0){
      biggest_power=*(mconf.spect.power+1);
   }
   for (j=1;j<length/2;j++)
       if (*(mconf.spect.power+j)>biggest_power) biggest_power=*(mconf.spect.power+j);
}
for (i=0;i<mconf.wave.rec_pn-length;i+=length)
{
   for (j=0;j<length;j++)
   {
	(mconf.spect.source+j)->re=*(mconf.wave.wave+i+j);
	(mconf.spect.source+j)->im=0;	
   }
   fft->fft();
   calc_power(length);
   if (i==0){
      least_power=*(mconf.spect.power+1);
   }
   for (j=1;j<length/2;j++)
   {
     if (*(mconf.spect.power+j)/biggest_power>0.01)
       if (*(mconf.spect.power+j)<least_power)
          least_power=*(mconf.spect.power+j);
   }   
}

}

void filter::ok()
{
int i,j;
int length;
QProgressDialog *pbar=new QProgressDialog("Frekvencia szures","Stop",mconf.wave.rec_pn,this);

pbar->show();
qApp->processEvents();
okb->setEnabled(FALSE);
mb->setEnabled(FALSE);
t1->setEnabled(FALSE);
t2->setEnabled(FALSE);
t3->setEnabled(FALSE);
hide();
  
if (mconf.nf!=NULL)
  free(mconf.nf);
mconf.nf=(noise_f *)calloc(fr_start->count(),sizeof(noise_f));
for (i=0;i<fr_start->count();i++)
  {
    (mconf.nf+i)->fr_start=atoi(fr_start->text(i));
    (mconf.nf+i)->fr_end=atoi(fr_end->text(i));
    (mconf.nf+i)->ampl=atoi(ampl->text(i));
    (mconf.nf+i)->time_start=atoi(time_start->text(i));
    (mconf.nf+i)->time_end=atoi(time_end->text(i));
  }
db=fr_start->count();
//length=(int)(log(mconf.wave.freq)/log(2));
length=13;
fft=new Fft();
fft->init(length);
length=1<<length;
if (mconf.spect.source!=NULL)		//Modified!!!! 
    free(mconf.spect.source);		//Modified!!!!
mconf.spect.source=(complex *)calloc(length,sizeof(complex));
//mconf.wave.window_length_pn=length;
ej=(int *)calloc(length,sizeof(int));
search_for_lnh(length);
pbar->setProgress(0);
for (i=0;i<mconf.wave.rec_pn-length;i+=(length-128))
{
	for (j=0;j<length;j++){
	   (mconf.spect.source+j)->re=*(mconf.wave.wave+j+i);
	   (mconf.spect.source+j)->im=0;
	}
	fft->fft();
        pbar->setProgress(i+length);
	qApp->processEvents();
	mconf.spect.pn=length/2;
	calc_power(length);
	szur(i/length,length);
	calc_cx(length); 
	fft->dft(i);
 }
free(ej);
free(mconf.spect.source);
mconf.wave.window_length=mconf.wave.rec_pn;
mconf.wave.window_start=0;
fft->close();
pbar->close();
okb->setEnabled(TRUE);
mb->setEnabled(TRUE);
t1->setEnabled(TRUE);
t2->setEnabled(TRUE);
t3->setEnabled(TRUE);
accept();
}

void filter::cancel()
{
  reject();
}

filter::~filter()
{
}
